# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class QueryModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'source_ids': 'list[str]',
        'token': 'str',
        'processed': 'list[bool]',
        'excluded': 'list[bool]',
        'created_by': 'str',
        'allowed_groups': 'list[str]',
        'status': 'list[str]',
        'existing_mappings': 'list[bool]',
        'tags': 'list[str]',
        'local_terms': 'list[str]',
        'target_terms': 'list[str]',
        'excluded_tags': 'list[str]',
        'categories': 'list[str]',
        'specialities': 'list[str]',
        'code': 'str',
        'requests': 'list[bool]',
        'specimens': 'list[bool]',
        'concept_ids': 'list[str]',
        'group_ids': 'list[str]',
        'organisation_ids': 'list[str]',
        'map_association_ids': 'list[str]',
        'code_list_ids': 'list[str]',
        'local_code_item_ids': 'list[str]',
        'type': 'list[str]',
        'states': 'list[str]',
        'send_away': 'list[bool]'
    }

    attribute_map = {
        'source_ids': 'sourceIds',
        'token': 'token',
        'processed': 'processed',
        'excluded': 'excluded',
        'created_by': 'createdBy',
        'allowed_groups': 'allowedGroups',
        'status': 'status',
        'existing_mappings': 'existingMappings',
        'tags': 'tags',
        'local_terms': 'localTerms',
        'target_terms': 'targetTerms',
        'excluded_tags': 'excludedTags',
        'categories': 'categories',
        'specialities': 'specialities',
        'code': 'code',
        'requests': 'requests',
        'specimens': 'specimens',
        'concept_ids': 'conceptIds',
        'group_ids': 'groupIds',
        'organisation_ids': 'organisationIds',
        'map_association_ids': 'mapAssociationIds',
        'code_list_ids': 'codeListIds',
        'local_code_item_ids': 'localCodeItemIds',
        'type': 'type',
        'states': 'states',
        'send_away': 'sendAway'
    }

    def __init__(self, source_ids=None, token=None, processed=None, excluded=None, created_by=None, allowed_groups=None, status=None, existing_mappings=None, tags=None, local_terms=None, target_terms=None, excluded_tags=None, categories=None, specialities=None, code=None, requests=None, specimens=None, concept_ids=None, group_ids=None, organisation_ids=None, map_association_ids=None, code_list_ids=None, local_code_item_ids=None, type=None, states=None, send_away=None):  # noqa: E501
        """QueryModel - a model defined in Swagger"""  # noqa: E501

        self._source_ids = None
        self._token = None
        self._processed = None
        self._excluded = None
        self._created_by = None
        self._allowed_groups = None
        self._status = None
        self._existing_mappings = None
        self._tags = None
        self._local_terms = None
        self._target_terms = None
        self._excluded_tags = None
        self._categories = None
        self._specialities = None
        self._code = None
        self._requests = None
        self._specimens = None
        self._concept_ids = None
        self._group_ids = None
        self._organisation_ids = None
        self._map_association_ids = None
        self._code_list_ids = None
        self._local_code_item_ids = None
        self._type = None
        self._states = None
        self._send_away = None
        self.discriminator = None

        if source_ids is not None:
            self.source_ids = source_ids
        if token is not None:
            self.token = token
        if processed is not None:
            self.processed = processed
        if excluded is not None:
            self.excluded = excluded
        if created_by is not None:
            self.created_by = created_by
        if allowed_groups is not None:
            self.allowed_groups = allowed_groups
        if status is not None:
            self.status = status
        if existing_mappings is not None:
            self.existing_mappings = existing_mappings
        if tags is not None:
            self.tags = tags
        if local_terms is not None:
            self.local_terms = local_terms
        if target_terms is not None:
            self.target_terms = target_terms
        if excluded_tags is not None:
            self.excluded_tags = excluded_tags
        if categories is not None:
            self.categories = categories
        if specialities is not None:
            self.specialities = specialities
        if code is not None:
            self.code = code
        if requests is not None:
            self.requests = requests
        if specimens is not None:
            self.specimens = specimens
        if concept_ids is not None:
            self.concept_ids = concept_ids
        if group_ids is not None:
            self.group_ids = group_ids
        if organisation_ids is not None:
            self.organisation_ids = organisation_ids
        if map_association_ids is not None:
            self.map_association_ids = map_association_ids
        if code_list_ids is not None:
            self.code_list_ids = code_list_ids
        if local_code_item_ids is not None:
            self.local_code_item_ids = local_code_item_ids
        if type is not None:
            self.type = type
        if states is not None:
            self.states = states
        if send_away is not None:
            self.send_away = send_away

    @property
    def source_ids(self):
        """Gets the source_ids of this QueryModel.  # noqa: E501


        :return: The source_ids of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._source_ids

    @source_ids.setter
    def source_ids(self, source_ids):
        """Sets the source_ids of this QueryModel.


        :param source_ids: The source_ids of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._source_ids = source_ids

    @property
    def token(self):
        """Gets the token of this QueryModel.  # noqa: E501


        :return: The token of this QueryModel.  # noqa: E501
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """Sets the token of this QueryModel.


        :param token: The token of this QueryModel.  # noqa: E501
        :type: str
        """

        self._token = token

    @property
    def processed(self):
        """Gets the processed of this QueryModel.  # noqa: E501


        :return: The processed of this QueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._processed

    @processed.setter
    def processed(self, processed):
        """Sets the processed of this QueryModel.


        :param processed: The processed of this QueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._processed = processed

    @property
    def excluded(self):
        """Gets the excluded of this QueryModel.  # noqa: E501


        :return: The excluded of this QueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._excluded

    @excluded.setter
    def excluded(self, excluded):
        """Sets the excluded of this QueryModel.


        :param excluded: The excluded of this QueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._excluded = excluded

    @property
    def created_by(self):
        """Gets the created_by of this QueryModel.  # noqa: E501


        :return: The created_by of this QueryModel.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this QueryModel.


        :param created_by: The created_by of this QueryModel.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def allowed_groups(self):
        """Gets the allowed_groups of this QueryModel.  # noqa: E501


        :return: The allowed_groups of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._allowed_groups

    @allowed_groups.setter
    def allowed_groups(self, allowed_groups):
        """Sets the allowed_groups of this QueryModel.


        :param allowed_groups: The allowed_groups of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._allowed_groups = allowed_groups

    @property
    def status(self):
        """Gets the status of this QueryModel.  # noqa: E501


        :return: The status of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this QueryModel.


        :param status: The status of this QueryModel.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["REVIEW", "FINALISED", "ESCALATED", "UNKNOWN"]  # noqa: E501
        if not set(status).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `status` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(status) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._status = status

    @property
    def existing_mappings(self):
        """Gets the existing_mappings of this QueryModel.  # noqa: E501


        :return: The existing_mappings of this QueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._existing_mappings

    @existing_mappings.setter
    def existing_mappings(self, existing_mappings):
        """Sets the existing_mappings of this QueryModel.


        :param existing_mappings: The existing_mappings of this QueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._existing_mappings = existing_mappings

    @property
    def tags(self):
        """Gets the tags of this QueryModel.  # noqa: E501


        :return: The tags of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this QueryModel.


        :param tags: The tags of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def local_terms(self):
        """Gets the local_terms of this QueryModel.  # noqa: E501


        :return: The local_terms of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._local_terms

    @local_terms.setter
    def local_terms(self, local_terms):
        """Sets the local_terms of this QueryModel.


        :param local_terms: The local_terms of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._local_terms = local_terms

    @property
    def target_terms(self):
        """Gets the target_terms of this QueryModel.  # noqa: E501


        :return: The target_terms of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._target_terms

    @target_terms.setter
    def target_terms(self, target_terms):
        """Sets the target_terms of this QueryModel.


        :param target_terms: The target_terms of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._target_terms = target_terms

    @property
    def excluded_tags(self):
        """Gets the excluded_tags of this QueryModel.  # noqa: E501


        :return: The excluded_tags of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._excluded_tags

    @excluded_tags.setter
    def excluded_tags(self, excluded_tags):
        """Sets the excluded_tags of this QueryModel.


        :param excluded_tags: The excluded_tags of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._excluded_tags = excluded_tags

    @property
    def categories(self):
        """Gets the categories of this QueryModel.  # noqa: E501


        :return: The categories of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._categories

    @categories.setter
    def categories(self, categories):
        """Sets the categories of this QueryModel.


        :param categories: The categories of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._categories = categories

    @property
    def specialities(self):
        """Gets the specialities of this QueryModel.  # noqa: E501


        :return: The specialities of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._specialities

    @specialities.setter
    def specialities(self, specialities):
        """Sets the specialities of this QueryModel.


        :param specialities: The specialities of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._specialities = specialities

    @property
    def code(self):
        """Gets the code of this QueryModel.  # noqa: E501


        :return: The code of this QueryModel.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this QueryModel.


        :param code: The code of this QueryModel.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def requests(self):
        """Gets the requests of this QueryModel.  # noqa: E501


        :return: The requests of this QueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._requests

    @requests.setter
    def requests(self, requests):
        """Sets the requests of this QueryModel.


        :param requests: The requests of this QueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._requests = requests

    @property
    def specimens(self):
        """Gets the specimens of this QueryModel.  # noqa: E501


        :return: The specimens of this QueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._specimens

    @specimens.setter
    def specimens(self, specimens):
        """Sets the specimens of this QueryModel.


        :param specimens: The specimens of this QueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._specimens = specimens

    @property
    def concept_ids(self):
        """Gets the concept_ids of this QueryModel.  # noqa: E501


        :return: The concept_ids of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._concept_ids

    @concept_ids.setter
    def concept_ids(self, concept_ids):
        """Sets the concept_ids of this QueryModel.


        :param concept_ids: The concept_ids of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._concept_ids = concept_ids

    @property
    def group_ids(self):
        """Gets the group_ids of this QueryModel.  # noqa: E501


        :return: The group_ids of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._group_ids

    @group_ids.setter
    def group_ids(self, group_ids):
        """Sets the group_ids of this QueryModel.


        :param group_ids: The group_ids of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._group_ids = group_ids

    @property
    def organisation_ids(self):
        """Gets the organisation_ids of this QueryModel.  # noqa: E501


        :return: The organisation_ids of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._organisation_ids

    @organisation_ids.setter
    def organisation_ids(self, organisation_ids):
        """Sets the organisation_ids of this QueryModel.


        :param organisation_ids: The organisation_ids of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._organisation_ids = organisation_ids

    @property
    def map_association_ids(self):
        """Gets the map_association_ids of this QueryModel.  # noqa: E501


        :return: The map_association_ids of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._map_association_ids

    @map_association_ids.setter
    def map_association_ids(self, map_association_ids):
        """Sets the map_association_ids of this QueryModel.


        :param map_association_ids: The map_association_ids of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._map_association_ids = map_association_ids

    @property
    def code_list_ids(self):
        """Gets the code_list_ids of this QueryModel.  # noqa: E501


        :return: The code_list_ids of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._code_list_ids

    @code_list_ids.setter
    def code_list_ids(self, code_list_ids):
        """Sets the code_list_ids of this QueryModel.


        :param code_list_ids: The code_list_ids of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._code_list_ids = code_list_ids

    @property
    def local_code_item_ids(self):
        """Gets the local_code_item_ids of this QueryModel.  # noqa: E501


        :return: The local_code_item_ids of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._local_code_item_ids

    @local_code_item_ids.setter
    def local_code_item_ids(self, local_code_item_ids):
        """Sets the local_code_item_ids of this QueryModel.


        :param local_code_item_ids: The local_code_item_ids of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._local_code_item_ids = local_code_item_ids

    @property
    def type(self):
        """Gets the type of this QueryModel.  # noqa: E501


        :return: The type of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this QueryModel.


        :param type: The type of this QueryModel.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["EXACT_MATCH", "LESS_SPECIFIC", "MORE_SPECIFIC", "NO_MATCH", "UNKNOWN"]  # noqa: E501
        if not set(type).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `type` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(type) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._type = type

    @property
    def states(self):
        """Gets the states of this QueryModel.  # noqa: E501


        :return: The states of this QueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._states

    @states.setter
    def states(self, states):
        """Sets the states of this QueryModel.


        :param states: The states of this QueryModel.  # noqa: E501
        :type: list[str]
        """

        self._states = states

    @property
    def send_away(self):
        """Gets the send_away of this QueryModel.  # noqa: E501


        :return: The send_away of this QueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._send_away

    @send_away.setter
    def send_away(self, send_away):
        """Sets the send_away of this QueryModel.


        :param send_away: The send_away of this QueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._send_away = send_away

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
